/* =================================================================================================

(c - MIT) T.W.J. de Geus (Tom) | tom@geus.me | www.geus.me | github.com/tdegeus/cppmat

================================================================================================= */

#ifndef CPPMAT_MAP_CARTESIAN_VECTOR_HPP
#define CPPMAT_MAP_CARTESIAN_VECTOR_HPP

// -------------------------------------------------------------------------------------------------

#include "cppmat.h"

// -------------------------------------------------------------------------------------------------

namespace cppmat {
namespace view {
namespace cartesian {

// =================================================================================================
// constructors
// =================================================================================================

template<typename X, size_t ND>
inline
vector<X,ND>::vector() : cppmat::view::vector<X,ND>()
{
}

// =================================================================================================
// constructors: map external pointer
// =================================================================================================

template<typename X, size_t ND>
inline
vector<X,ND>::vector(const X *A) : cppmat::view::vector<X,ND>(A)
{
}

// =================================================================================================
// named constructors
// =================================================================================================

template<typename X, size_t ND>
inline
vector<X,ND> vector<X,ND>::Map(const X *D)
{
  vector<X,ND> out;

  out.setMap(D);

  return out;
}

// =================================================================================================
// dimensions
// =================================================================================================

template<typename X, size_t ND>
inline
size_t vector<X,ND>::ndim() const
{
  return ND;
}

// =================================================================================================

}}} // namespace ...

// -------------------------------------------------------------------------------------------------

#endif

